/*
getpb.c  Version 0.3.0 Powerball Odds
Copyright (C) 2002-2010   dondalah721@yahoo.com (Dondalah)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License as
published by the Free Software Foundation; either version 2 of
the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to:

	Free Software Foundation, Inc.
	59 Temple Place - Suite 330
	Boston, MA  02111-1307, USA.
*/

/*
Usage:
    	int select;
    	int pwrball;
    	double odds;
    	double getpb(int select, int pwrball);
    	odds = getpb(select,pwrball);
*/

#include <stdio.h>
#include <stdlib.h>

#define WHITEBALL 53
#define PWRBALL   42

double getpb(select,pwrball)
int select;
int pwrball;
   {
   int notwin;
   double odds;
   double maxwhball;
   double topwin,toplose;
   double top;
   double bottom;
   double dblwhball,dblnotwin,dbllose;
   double dblpball;
   double dblnotpb;
   double combo(int n, int r);

   if (select < 0 || select > 5)
      {
      fprintf(stderr,"getpb: invalid select %d\n",
         select);
      exit(1);
      } /* invalid select */
   if (pwrball < 0 || pwrball > 1)
      {
      fprintf(stderr,"getpb: invalid powerball %d\n",
         pwrball);
      exit(1);
      } /* invalid pwrball */
   if (select >= 0 && select <= 2)
      {
      if (pwrball != 1)
         {
         fprintf(stderr,"getpb: invalid powerball %d "
            "when select is %d\n",
            pwrball, select);
         exit(1);
         } /* invalid pwrball */
      } /* select = 2,1,0 */

   maxwhball = WHITEBALL;
   dblpball  = PWRBALL;
   dblwhball = (double) maxwhball;
   notwin    = maxwhball - 5;
   dblnotwin = dblwhball - 5.0;
   dbllose   = dblwhball - 1.0;
   dblnotpb  = dblpball - 1.0;

   if (select == 5 && pwrball == 1)
      {
      top = combo(5,select);
      bottom = combo(maxwhball,5) * dblpball;
      odds = bottom / top;
      return(odds);
      } /* 5 1 */

   else if (select == 5 && pwrball == 0)
      {
      topwin  = combo(5,select);
      toplose = dblnotpb;
      top = topwin * toplose;
      bottom = combo(maxwhball,5) * dblpball;
      odds = bottom / top;
      return(odds);
      } /* 5 0 */

   else if (select == 4 && pwrball == 1)
      {
      topwin  = combo(5,select);
      toplose = combo(notwin,5 - select);
      top = topwin * toplose;
      bottom = combo(maxwhball,5) * dblpball;
      odds = bottom / top;
      return(odds);
      } /* 4 1 */

   else if (select == 4 && pwrball == 0)
      {
      topwin  = combo(5,select);
      toplose = combo(notwin,5 - select) * dblnotpb;
      top = topwin * toplose;
      bottom = combo(maxwhball,5) * dblpball;
      odds = bottom / top;
      return(odds);
      } /* 4 0 */

   else if (select == 3 && pwrball == 1)
      {
      topwin  = combo(5,select);
      toplose = combo(notwin,5 - select);
      top = topwin * toplose;
      bottom = combo(maxwhball,5) * dblpball;
      odds = bottom / top;
      return(odds);
      } /* 3 1 */

   else if (select == 3 && pwrball == 0)
      {
      topwin  = combo(5,select);
      toplose = combo(notwin,5 - select) * dblnotpb;
      top = topwin * toplose;
      bottom = combo(maxwhball,5) * dblpball;
      odds = bottom / top;
      return(odds);
      } /* 3 0 */

   else if (select == 2 && pwrball == 1)
      {
      topwin  = combo(5,select);
      toplose = combo(notwin,5 - select);
      top = topwin * toplose;
      bottom = combo(maxwhball,5) * dblpball;
      odds = bottom / top;
      return(odds);
      } /* 2 1 */

   else if (select == 1 && pwrball == 1)
      {
      topwin  = combo(5,select);
      toplose = combo(notwin,5 - select);
      top = topwin * toplose;
      bottom = combo(maxwhball,5) * dblpball;
      odds = bottom / top;
      return(odds);
      } /* 1 1 */

   else if (select == 0 && pwrball == 1)
      {
      topwin  = combo(5,select);
      toplose = combo(notwin,5 - select);
      top = topwin * toplose;
      bottom = combo(maxwhball,5) * dblpball;
      odds = bottom / top;
      return(odds);
      } /* 0 1 */
   fprintf(stderr,"getpb: edit failed for "
      "powerball %d when select is %d\n",
      pwrball, select);
   exit(1);
   } /* getpb */
